library ExcelExport;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  SysUtils, ActiveX, ComObj, Variants,
  Classes,
  UPluginSDK in '..\..\UPluginSDK.pas';

const
  AppName='ViRUS FL Excel Plugin v0.1.2';
  nActiveColCount=21;

{$R *.res}
{$E vlp}

function FLMode:integer;
begin
  result:=1;//Export;
//  resulr:=2;//Import;
end;

function GetDisplayName : PChar;
begin
  result:=PChar(AppName);
end;

function GetFilterMask : PChar;
begin
  result:=PChar('Excel files(*.xls)|*.xls');
end;

function IsXLSPossible: boolean;
var
  ClassID: TCLSID;
  Res : HRESULT;
begin
  //  CLSID OLE-
  Res := CLSIDFromProgID(PWideChar(WideString('Excel.Application')), ClassID);
  if Res = S_OK then  //  
    Result := true
  else
    Result := false;
end;

function ExportTo(pcFileName, pcData : PChar) : boolean;
var
  p : TvtVLFParser;
  i,j,k : Integer;
  Excel, WorkBook, WorkSheet, Cell1, Cell2 : Variant;
  VArray : variant;
  aColumnsWidth : array [0..nActiveColCount] of real;
begin
  p:=TvtVLFParser.Create;
  p.Parse(string(pcData));

  aColumnsWidth[0]:=4.29;
  aColumnsWidth[3]:=4.29;
  aColumnsWidth[4]:=2.86;
  aColumnsWidth[11]:=4.29;  
  aColumnsWidth[12]:=3;  
  aColumnsWidth[16]:=9.14;
  result:=true;
  if not IsXLSPossible then
  begin
    result:=false;
    exit;
  end;
  Excel:=CreateOleObject('Excel.Application');
  Excel.Application.EnableEvents:=false;
  Excel.Visible:=False;
  WorkBook:=Excel.Workbooks.Add;
  while WorkBook.WorkSheets.Count>1 do
    Workbook.WorkSheets[1].Delete;
  if p.nListsCount>1 then
    for k:=2 to p.nListsCount do
      WorkBook.WorkSheets.Add;
  for k:=1 to p.nListsCount do
  begin
    WorkSheet:=Workbook.WorkSheets[k];
//    lvList.ChangeList(k);
    WorkSheet.Name:=p.aLists[k-1].sName;
    VArray:=VarArrayCreate([1,p.aLists[k-1].nItemsCount+1,1,nActiveColCount],varVariant);
    for i:=2 to p.aLists[k-1].nItemsCount+1 do
    begin
      for j:=1 to nActiveColCount do
        VArray[i,j]:=p.aLists[k-1].aItems[j-1,i-2];
      WorkSheet.Range['A'+IntToStr(i),chr(ord('A')+nActiveColCount-1)+IntToStr(i)].RowHeight:=12;
//      WorkSheet.Range['A'+IntToStr(i),chr(ord('A')+nActiveColCount-1)+IntToStr(i)].Interior.Color:=StrToInt('$'+p.aLists[k-1].aItems[20,i-2]);
    end;
    for i:=1 to nActiveColCount do
    begin
      VArray[1,i]:=p.aLists[k-1].aColumnsName[i-1];
//new TVM
//  Excel.Range['A2', 'A2'].Font.Size := 20;
//  Excel.Range['A2', 'A2'].Font.FontStyle := 'Bold';
//  Excel.Range['A2', 'A2'].Font.Color := clFuchsia;
//  Excel.Range['A2', 'A2'].Font.Name := 'Arial';
//
//  //       
//  Excel.Range['B2', 'C6'].Interior.Color := RGB(223, 123, 123);
      if aColumnsWidth[i-1]>0 then
        WorkSheet.Range[chr(ord('A')+i-1)+'1',chr(ord('A')+i-1)+'10'].ColumnWidth:=aColumnsWidth[i-1];

      //Columns.ColumnWidth:=30; //(chr(ord('A')+i-1)+':'+chr(ord('A')+i-1)).Width:=30;
//-new TVM
    end;
    WorkSheet.Range['F1','G1'].Columns.Group;
    WorkSheet.Range['N1','P1'].Columns.Group;
    Cell1:=WorkSheet.Cells[1,1];
    Cell2:=WorkSheet.Cells[p.aLists[k-1].nItemsCount+1,nActiveColCount];
    WorkSheet.Range[Cell1,Cell2].Value:=VArray;
  end;

  if FileExists(string(pcFileName)) then
    DeleteFile(string(pcFileName));

  Workbook.SaveAs(string(pcFileName));
//  Workbook.Save;
  Workbook.Close;
  Excel.Quit;

  p.Free;
end;
{
function ImportFrom(sFileName : PChar) : PChar;
begin
end;}

exports
  FLMode, GetDisplayName, GetFilterMask, ExportTo;

begin

end.

