unit UPluginSDK;

interface

uses Classes, SysUtils;

const
  nColumnsCount=21;

type
  TvtList=class
    sName : string;
    aItems : array of array of string;
    aColumnsName : array of string;
    nItemsCount : integer;
    constructor Create(nCount : integer);
  end;
  TvtVLFParser=class
    nListsCount : integer;
    aLists : array of TvtList;
    function Parse(sStr : string):boolean;
    function Generate : string;
  end;

implementation

{ vtList }

constructor TvtList.Create(nCount: integer);
var
  i : integer;
begin
  nItemsCount:=nCount;
  SetLength(aItems,nColumnsCount);
  for i:=0 to nColumnsCount-1 do
    SetLength(aItems[i],nCount);
  SetLength(aColumnsName,nColumnsCount);
end;

{ vtVLFParser }

function TvtVLFParser.Generate: string;
begin

end;

function Replace(str, ToRepl, ReplStr : string; CaseIns : boolean=false) : string;
var
  s : string;
begin
  s:=str;
  if not CaseIns then
  begin
    s:=AnsiLowerCase(s);
    ToRepl:=AnsiLowerCase(ToRepl);
  end;
  while pos(ToRepl,s)<>0 do
  begin
    str:=copy(str,1,pos(ToRepl,s)-1)+ReplStr+copy(str,pos(ToRepl,s)+length(ToRepl),
              length(str)-pos(ToRepl,s)-length(ToRepl)+1);
    if not CaseIns then
      s:=AnsiLowerCase(str)
    else
      s:=str;
  end;
  result:=str;
end;

function GetString(s : TStringList;var index : integer) : string;
begin
  result:=s.Strings[index];
  inc(index);
end;

function RemoveBR(str : string) : string;
begin
  result:=replace(str,'<br>',#$D#$A);
end;

function TvtVLFParser.Parse(sStr: string): boolean;
var
  str1, list : string;
  t, lists, i, l, k, i1, iString : integer;
  aStr : TStringList;
begin
  aStr:=TStringList.Create;
  aStr.SetText(PChar(sStr));
  iString:=1;
  str1:=aStr.Strings[0];
  if str1='vlf v1.3' then
  begin
    lists:=StrToInt(GetString(aStr,iString));
    for i1:=1 to lists do
    begin
      list:=GetString(aStr,iString);
      Inc(nListsCount);
      SetLength(aLists,nListsCount);
      t:=StrToInt(GetString(aStr,iString));
      aLists[nListsCount-1]:=TvtList.Create(t);
      aLists[nListsCount-1].sName:=list;
      for i:=0 to 20 do
      begin
        aLists[nListsCount-1].aColumnsName[i]:=GetString(aStr,iString);
      end;
      for k:=1 to t do
      begin
        for i:=0 to 20 do
        begin
          aLists[nListsCount-1].aItems[i,k-1]:=RemoveBR(GetString(aStr,iString));
        end;
      end;
    end;
  end
end;

end.
